<template>
  <template
    v-if="allowCompany && pageStyleProperty?.Text === 'Banner_style_02'"
  >
    <banner-mobile-overflow
      v-if="IsShowBanner"
      :auth="authentication"
      :theme-properties="themeProperties"
      :actived="actived"
      :theme-banner-for-display="sortedBanner"
    />
  </template>
  <template v-else>
    <lazy-banner-mobile
      v-if="IsShowBanner || !allowCompany"
      :key="activedTab"
      :style-selected="pageStyleProperty?.Text"
      :theme-properties="themeProperties"
      :actived="actived"
      :theme-banner-for-display="sortedBanner"
    />
  </template>
</template>

<script lang="ts" setup>
import _ from "lodash";
import { ref, Ref, computed, watch, PropType } from "vue";
import { store } from "@/store";
import { ThemePropertiesFromApiDto } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import commonHelper from "@/utils/commonHelper";

const props = defineProps({
  activedTab: {
    type: String,
    default: "",
  },
  height: {
    type: String,
    default: "auto",
  },
  maxHeight: {
    type: Number,
    default: 0,
  },
  bannerKeys: {
    type: Object as PropType<Record<string, string>>,
    required: true,
  },
});
const actived = computed(() => _.toLower(props.activedTab));
const themeProperties =
  store.state.companyThemePropertiesFromApi.ThemeProperties;
const bannerKey = computed(
  () => props.bannerKeys[actived.value] ?? props.bannerKeys.home
);
const themeBannerForDisplay: Ref<Array<ThemePropertiesFromApiDto>> = ref(
  themePropertyHelper.getMultipleThemesProperties(
    themeProperties,
    bannerKey.value
  )
);
if (actived.value === "sports") {
  themeBannerForDisplay.value = _.filter(
    themeBannerForDisplay.value,
    (theme) => !_.includes(theme.HtmlId, "virtual_")
  );
}
const componentKey = ref(1);

const getBanners = () => {
  const banners = themePropertyHelper.getMultipleThemesProperties(
    themeProperties,
    bannerKey.value
  );
  themeBannerForDisplay.value = _.sortBy(banners, (banner) => {
    const htmlidSplit = banner.HtmlId.split("_");
    const bannerNumber = parseInt(htmlidSplit[htmlidSplit.length - 1]);
    return bannerNumber;
  });
  if (actived.value === "sports") {
    themeBannerForDisplay.value = _.filter(
      themeBannerForDisplay.value,
      (theme) => !_.includes(theme.HtmlId, "virtual_")
    );
  }
  componentKey.value += 1;
};

watch(props, () => {
  getBanners();
});
const resizing = ref();
setInterval(() => {
  resizing.value = window.innerWidth;
}, 500);
const autoBannerHeight = computed(() => {
  if (props.height === "auto") {
    let height = resizing.value / 3.5;
    if (props.maxHeight && height >= props.maxHeight) {
      height = props.maxHeight;
    }

    return `${height}px`;
  }
  return props.height;
});
const isBannerEnabled = computed(
  (): boolean => themeBannerForDisplay.value.length !== 0
);
const keyForMap: Record<string, string> = {
  home: "home_page_banner_style",
  sports: "sports_page_banner_style",
  livecasino: "live_casino_page_banner_style",
  games: "games_page_banner_style",
  virtualsports: "virtual_sports_page_banner_style",
  cockfight: "cockfight_page_banner_style",
  promotion: "promotion_page_banner_style",
  lottery: "lottery_page_banner_style",
  poker: "poker_page_banner_style",
};
const allBannerPageStyle = themePropertyHelper.getAllMultipleThemesProperties(
  themeProperties,
  "_page_banner_style"
);
const pageStyleProperty = computed(() =>
  allBannerPageStyle.find((item) => item.HtmlId === keyForMap[actived.value])
);

const sortedBanner = computed(() => {
  const hasResorcekeyValue = themeBannerForDisplay.value.some(
    (item) => item.ResourceKey
  );
  if (hasResorcekeyValue && allowCompany.value) {
    return _.sortBy(
      _.cloneDeep(themeBannerForDisplay.value).filter(
        (item) => item.Text === "shown" || !item.IsHidden
      ),
      (prop: ThemePropertiesFromApiDto) => {
        if (prop.ResourceKey) {
          return Number(prop.ResourceKey);
        }
        return 999;
      }
    );
  }
  return themeBannerForDisplay.value;
});
const { allowCompany } = commonHelper;

const IsShowBanner = computed(() => {
  if (allowCompany.value)
    return (
      (!pageStyleProperty.value?.IsHidden ?? false) &&
      sortedBanner.value?.length > 0
    );
  return isBannerEnabled.value;
});

onMounted(() => {
  getBanners();
});
</script>
<style lang="scss">
[theme-color="bk8_green"] {
  .el-carousel {
    border-radius: 0 !important;
  }
}
.Banner_style_03 {
  .el-carousel__indicators.el-carousel__indicators--horizontal {
    .el-carousel__indicator.el-carousel__indicator--horizontal {
      .el-carousel__button {
        width: 14px;
        height: 7px;
        border-radius: 4px;
        opacity: 1;
        background: var(--text5, #fff);
      }
    }
    .el-carousel__indicator.el-carousel__indicator--horizontal.is-active {
      .el-carousel__button {
        background: var(--primary);
        opacity: 1;
        width: 40px;
      }
    }
  }
}
</style>

<style scoped>
.btn {
  @apply inline-block text-center rounded-2xl text-white duration-300;
  min-width: 160px;
  margin-right: 1rem;
  width: 160px;
  margin-top: 26px;
  padding: 8px 20px;
}

.btn.--primary {
  color: black;
  background-color: var(--primary);
}
.btn.--primary:hover {
  color: white;
  background-color: var(--secondary);
}
.hsport_wrapper {
  background: #111;
  background-position: center 0;
  background-size: cover;
  padding-top: 88px;
  padding-bottom: 88px;
  width: 100%;
  margin-top: 80px;
}
.back-img {
  @apply w-full h-full object-cover relative top-0 right-0;
}
.stage {
  display: flex;
  height: 430px;
  width: 110%;
}
.logo-banner {
  position: absolute;
  top: -3px;
  right: 137px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
}
.el-carousel__item.is-active .ball-1 {
  animation: fadeInUp-ball 1s ease backwards;
}
.el-carousel__item.is-active .white-paper-1 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .white-paper-2 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .white-paper-3 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .orange-paper-1 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .orange-paper-2 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .dice-1 {
  animation: fadeInUp-left 1s ease backwards;
}
.el-carousel__item.is-active .dice-2 {
  animation: fadeInUp-left 2s ease backwards;
}
.el-carousel__item.is-active .coin-1 {
  animation: fadeInUp 1s ease backwards;
}
.el-carousel__item.is-active .ball-3 {
  animation: fadeInUp-right 2s ease backwards;
}
.el-carousel__item.is-active .black-dice-1 {
  animation: fadeInUp 2s ease backwards;
}
.el-carousel__item.is-active .black-dice-2 {
  animation: fadeInUp 2s ease backwards;
}
.el-carousel__item.is-active .black-dice-3 {
  animation: fadeInUp 2s ease backwards;
}
.el-carousel__item.is-active .black-coin-1 {
  animation: fadeInUp 2s ease backwards;
}
.el-carousel__item.is-active .black-coin-2 {
  animation: fadeInUp 2s ease backwards;
}
.el-carousel__item.is-active .card-1 {
  animation: fadeInDown-left 1.2s ease backwards;
}
.el-carousel__item.is-active .red-dice-1 {
  animation: fadeInUp 1.7s ease backwards;
}
.el-carousel__item.is-active .red-coin-1 {
  animation: fadeInDown-left 1.2s ease backwards;
}
.el-carousel__item.is-active .blackjack-1 {
  animation: rotateIn 1.5s ease backwards;
}
@keyframes fadeInUp {
  0% {
    transform: translate(0px, 200px);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
@keyframes fadeInUp-ball {
  0% {
    transform: translate(150px, 150px);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
@keyframes fadeInUp-left {
  0% {
    transform: translate(250px, 50px);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
@keyframes fadeInDown-left {
  0% {
    transform: translate(250px, -50px);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
@keyframes fadeInUp-right {
  0% {
    transform: translate(-150px, 300px);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
@keyframes rotateIn {
  0% {
    transform: translate(150px, -50px) rotate(120deg);
    opacity: 0;
  }
  100% {
    transform: translate(0px, 0);
    opacity: 1;
  }
}
.stage {
  display: flex;
  height: 330px;
  width: 100%;
}
.ball-1 {
  position: absolute;
  top: -130px;
  left: -40px;
}
.ball-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 80px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 80px;
}
.white-paper-1 {
  position: absolute;
  top: -130px;
  left: -140px;
}
.white-paper-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 60px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 60px;
}
.white-paper-2 {
  position: absolute;
  top: -180px;
  left: 140px;
}
.white-paper-2-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 50px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 50px;
}
.white-paper-3 {
  position: absolute;
  top: -255px;
  left: 68px;
}
.white-paper-3-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 40px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 40px;
}
.orange-paper-1 {
  position: absolute;
  top: -120px;
  left: -400px;
}
.orange-paper-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 90px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 90px;
}
.orange-paper-2 {
  position: absolute;
  top: -250px;
  left: 240px;
}
.orange-paper-2-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 70px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 140px;
}
.dice-1 {
  position: absolute;
  top: -235px;
  left: -380px;
}
.dice-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 80px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 80px;
}
.dice-2 {
  position: absolute;
  top: -135px;
  left: -320px;
}
.dice-2-float {
  align-self: flex-end;
  animation-duration: 5s;
  animation-iteration-count: infinite;
  height: 55px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 55px;
}
.coin-1 {
  position: absolute;
  top: -30px;
  left: 30px;
}
.coin-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 66px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 69px;
}
.ball-3 {
  position: absolute;
  top: -100px;
  left: 370px;
}
.ball-3-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 110px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 107px;
}
.black-dice-1 {
  position: absolute;
  top: -315px;
  left: 68px;
}
.black-dice-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 45px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 145px;
}
.black-dice-2 {
  position: absolute;
  top: -250px;
  left: -68px;
}
.black-dice-2-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 45px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 150px;
}
.black-dice-3 {
  position: absolute;
  top: -185px;
  left: 38px;
}
.black-dice-3-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 60px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 140px;
}
.black-coin-1 {
  position: absolute;
  top: -175px;
  left: -98px;
}
.black-coin-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 90px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 90px;
}
.black-coin-2 {
  position: absolute;
  top: -245px;
  left: 48px;
}
.black-coin-2-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 50px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 50px;
}
.card-1 {
  position: absolute;
  top: -150px;
  left: -385px;
}
.card-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 80px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 80px;
}
.red-dice-1 {
  position: absolute;
  top: -138px;
  left: -86px;
}
.red-dice-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 50px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 50px;
}
.red-coin-1 {
  position: absolute;
  top: -245px;
  left: 48px;
}
.red-coin-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 50px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 50px;
}
.coinbox-1 {
  position: absolute;
  bottom: 0px;
  left: 1px;
}
.coinbox-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  height: 368px;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 1200px;
}
.girl-1 {
  position: absolute;
  bottom: 0px;
  left: 8px;
}
.girl-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  width: 1900px;
}
.blackjack-1 {
  position: absolute;
  bottom: 0px;
  left: -50px;
}
.blackjack-1-float {
  align-self: flex-end;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  margin: 0 auto 0 auto;
  transform-origin: bottom;
  width: 280px;
}
.bounce-1 {
  animation-name: bounce-1;
  animation-timing-function: linear;
}
@keyframes bounce-1 {
  0% {
    transform: translateX(0);
  }
  50% {
    transform: translateX(-1px);
  }
  100% {
    transform: translateX(0);
  }
}
.bounce-2 {
  animation-name: bounce-2;
  animation-timing-function: linear;
}
@keyframes bounce-2 {
  0% {
    transform: translateY(0);
  }
  50% {
    transform: translateY(-3px);
  }
  100% {
    transform: translateY(0);
  }
}
</style>
